%% $Id: psdAPI.tex,v 1.1 2001/04/02 20:37:00 Philip.Charlton Exp $

%% Start of test PSDEstimate01
\pagebreak
\renewcommand{\arraystretch}{1.5}       
\noindent
\begin{tabular}{@{}p{10em}@{}p{24em}@{}}
{\bf Test Case:}        & PSDEstimate01 \\
{\bf Purpose: }         & To test that {\tt std::invalid\_argument} 
                          exceptions thrown by the Welch estimate object 
                          for a zero length sequence, fft length = 0,
                          overlap length = fft length, and overlap length
                          $>$ fft length are caught and recorded at the 
                          Tcl layer. \\
{\bf Tester: }          & \rule{15em}{.1pt} \\
{\bf Test machine: }    & \rule{15em}{.1pt} \\
{\bf Date (mm/dd/yy): } & \rule{2em}{.1pt}/\rule{2em}{.1pt}/\rule{2em}{.1pt}
\hspace{2em} {\bf Time: } \rule{6em}{.1pt}\\
\end{tabular}
\renewcommand{\arraystretch}{1} 
\vspace{1em}

\noindent   
{\bf NOTE:} 
This test should be performed for real float (R4), real double (R8), 
complex float (C8), and complex double (C16) data types.
\vspace{1em}
            
\noindent   
{\bf ENVIRONMENT AND PREREQUISITES}
\vspace{1em} 
             
\noindent    
The following input data sets are required for this test:
\begin{enumerate}
\item N10XX.sim
\end{enumerate} 
where XX is either R4, R8, C8, or C16.
\vspace{1em} 
             
\noindent    
{\bf PROCEDURE}
\begin{enumerate}
             
\item Indicate which data type is currently being tested.\\
\hspace*{\fill} {\bf R4/ R8/ C8/ C16}

\item (Zero length sequence) Issue the ldas command
\begin{verbatim}
ldasJob { -name user -password ***** -email user@host }
  { conditionData 
    -inputprotocol file:/mdc/input/N10XX.sim
    -inputformat ilwd 
    -returnprotocol file:/mdc/output/PSDAPI01AXX.ilwd
    -returnformat ilwd 
    -resultname {none} 
    -resultcomment {none}
    -aliases {data=chan_01:data }
    -algorithms { 
      x = slice(data, 0, 0, 1);
      intermediate(,,chan_01:data,{slice of input data});
      rx = real(x);
      n = size(rx);
      intermediate(,,size,{size of input data});
      spec = psd(freq, x);
   } 

}
\end{verbatim} 
\hspace*{\fill} {\bf Pass / Fail}

\item Verify that a {\tt std::invalid\_argument} exception appears in 
the appropriate log file.\\ 
\hspace*{\fill} {\bf Pass / Fail}

\item (fft length = 0) Issue the ldas command
\begin{verbatim}
ldasJob { -name user -password ***** -email user@host }
  { conditionData 
    -inputprotocol file:/mdc/input/N10XX.sim
    -inputformat ilwd 
    -returnprotocol file:/mdc/output/PSDAPI01BXX.ilwd
    -returnformat ilwd 
    -resultname {none} 
    -resultcomment {none}
    -aliases {data=chan_01:data }
    -algorithms { 
      x = slice(data, 0, 1024, 1);
      intermediate(,,chan_01:data,{slice of input data});
      rx = real(x);
      n = size(rx);
      intermediate(,,size,{size of input data});
      spec = psd(freq, x, 0);
   } 

}
\end{verbatim} 
\hspace*{\fill} {\bf Pass / Fail}

\item Verify that a {\tt std::invalid\_argument} exception appears in 
the appropriate log file.\\ 
\hspace*{\fill} {\bf Pass / Fail}

\item (overlap length = fft length) Issue the ldas command
\begin{verbatim}
ldasJob { -name user -password ***** -email user@host }
  { conditionData 
    -inputprotocol file:/mdc/input/N10XX.sim
    -inputformat ilwd 
    -returnprotocol file:/mdc/output/PSDAPI01CXX.ilwd
    -returnformat ilwd 
    -resultname {none} 
    -resultcomment {none}
    -aliases {data=chan_01:data }
    -algorithms { 
      x = slice(data, 0, 1024, 1);
      intermediate(,,chan_01:data,{slice of input data});
      rx = real(x);
      n = size(rx);
      intermediate(,,size,{size of input data});
      spec = psd(freq, x, 1024, _, 1024);
   } 

}
\end{verbatim} 
\hspace*{\fill} {\bf Pass / Fail}

\item Verify that a {\tt std::invalid\_argument} exception appears in 
the appropriate log file.\\ 
\hspace*{\fill} {\bf Pass / Fail}

\item (overlap length $>$ fft length) Issue the ldas command
\begin{verbatim}
ldasJob { -name user -password ***** -email user@host }
  { conditionData 
    -inputprotocol file:/mdc/input/N10XX.sim
    -inputformat ilwd 
    -returnprotocol file:/mdc/output/PSDAPI01DXX.ilwd
    -returnformat ilwd 
    -resultname {none} 
    -resultcomment {none}
    -aliases {data=chan_01:data }
    -algorithms { 
      x = slice(data, 0, 1024, 1);
      intermediate(,,chan_01:data,{slice of input data});
      rx = real(x);
      n = size(rx);
      intermediate(,,size,{size of input data});
      spec = psd(freq, x, 1024, _, 1025);
   } 

}
\end{verbatim} 
\hspace*{\fill} {\bf Pass / Fail}

\item Verify that a {\tt std::invalid\_argument} exception appears in 
the appropriate log file.\\ 
\hspace*{\fill} {\bf Pass / Fail}

\end{enumerate}

\noindent    
{\bf SUMMARY}
\vspace{1em} 
             
\noindent    
{\bf Known faults encountered -- list bug IDs: }\hrulefill\\
\vspace{1em} 
\hrule       
\vspace{1em} 
\noindent    
{\bf New faults submitted -- list bug IDs: }\hrulefill \\
\vspace{1em} 
\hrule       
\vspace{2em} 
             
\noindent
{\bf TEST RESULT } \hfill {\bf Pass / Fail }\\
%% End of test PSDEstimate01

%% Start of test PSDEstimate02
\pagebreak
\renewcommand{\arraystretch}{1.5}       
\noindent
\begin{tabular}{@{}p{10em}@{}p{24em}@{}}
{\bf Test Case:}        & PSDEstimate02 \\
{\bf Purpose: }         & To verify that the Welch estimate apply method 
                          returns correct results for the power spectrum
                          estimate and discrete frequency values for different 
                          choices of the fft length and overlap length.\\
{\bf Tester: }          & \rule{15em}{.1pt} \\
{\bf Test machine: }    & \rule{15em}{.1pt} \\
{\bf Date (mm/dd/yy): } & \rule{2em}{.1pt}/\rule{2em}{.1pt}/\rule{2em}{.1pt}
\hspace{2em} {\bf Time: } \rule{6em}{.1pt}\\
\end{tabular}
\renewcommand{\arraystretch}{1} 
\vspace{1em}
             
\noindent    
{\bf NOTE:}  
This test should be performed for real float (R4), real double (R8), 
complex float (C8), and complex double (C16) data types.
\vspace{1em} 
             
\noindent    
{\bf ENVIRONMENT AND PREREQUISITES}
\vspace{1em} 
             
\noindent    
The following data sets are required for this test:
             
\begin{enumerate}
             
\item Input data:
             
\begin{enumerate}
\item N10XX.sim
\end{enumerate} 
             
where XX is either R4, R8, C8, or C16.
These data sets consist of sequences of random numbers.
             
\item Expected results:
             
\begin{enumerate}
\item PSDAPI02AXX.exp (default fft length, default overlap length) 
\item PSDAPI02BXX.exp (fft length = 256, overlap length = 0)
\item PSDAPI02CXX.exp (fft length = 256, overlap length = 128)
\end{enumerate}
             
where XX is R4, R8, C8, or C16.
These data sets contain the expected results for different power 
spectrum estimates (defined by different fft lengths and overlap 
lengths) for input data of length $N=1024$.

\end{enumerate}
\vspace{1em} 
             
\noindent    
{\bf PROCEDURE}
\begin{enumerate}
             
\item Indicate which data type is currently being tested.\\
\hspace*{\fill} {\bf R4/ R8/ C8/ C16}
             
\item (default fft length, default overlap length) Issue the following ldas command
\begin{verbatim}
ldasJob { -name user -password ***** -email user@host }
  { conditionData 
    -inputprotocol { 
      file:/mdc/input/N10XX.sim
      file:/mdc/input/PSDAPI02AXX.exp 
    }
    -inputformat ilwd 
    -returnprotocol file:/PSDAPI02AXX.ilwd
    -returnformat ilwd 
    -aliases {data=chan_01:data; freqexp=freqout:data; specexp=specout:data} 
    -algorithms { 
      x = slice(data, 0, 1024, 1);
      intermediate(,,chan_01:data,{slice of input data});
      
      spec = psd(freq, x);
      intermediate(,,spec,{spec});

      value(specexp);
      intermediate(,,specexp,{specexp});

      specdif = sub(spec, specexp);
      intermediate(,,specdif,{diff of spec and specexp});

      specmin = min(specdif);
      intermediate(,,specmin,{minimum of difference});

      specmax = max(specdif);
      intermediate(,,specmax,{maximum of difference});

      specrms = rms(specexp);
      intermediate(,,specrms,{root mean square of expected result});

      value(freq);
      intermediate(,,freq,{freq});

      value(freqexp);
      intermediate(,,freqexp,{freqexp});

      freqdif = sub(freq, freqexp);
      intermediate(,,freqdif,{freqdif});

      freqmin = min(freqdif);
      intermediate(,,freqmin,{minimum of difference});

      freqmax = max(freqdif);
      intermediate(,,freqmax,{maximum of difference});

      freqrms = rms(freqexp);
   } 
   -resultname {freqrms} 
   -resultcomment {root mean square of expected result} 
}
\end{verbatim} 
\hspace*{\fill} {\bf Pass / Fail}

\item Verify that the minimimum and maximum values of the differences for 
the power spectrum estimate and discrete frequency values are zero to floating 
point (or double) precision relative to the rms amplitude of the 
expected power spectrum estimate and discrete frequency values.\\
\hspace*{\fill} {\bf Pass / Fail}
\item Move the output file to {\tt mdc/output/api}.\\
\hspace*{\fill} {\bf Pass / Fail}

\item (fft length = 256, overlap length = 0) 
Issue the following ldas command
\begin{verbatim}
ldasJob { -name user -password ***** -email user@host }
  { conditionData 
    -inputprotocol { 
      file:/mdc/input/N10XX.sim
      file:/mdc/input/PSDAPI02BXX.exp 
    }
    -inputformat ilwd 
    -returnprotocol file:/PSDAPI02BXX.ilwd
    -returnformat ilwd 
    -aliases {data=chan_01:data; freqexp=freqout:data; specexp=specout:data} 
    -algorithms { 
      x = slice(data, 0, 1024, 1);
      intermediate(,,chan_01:data,{slice of input data});
      
      spec = psd(freq, x, 256, _, 0);
      intermediate(,,spec,{spec});

      value(specexp);
      intermediate(,,specexp,{specexp});

      specdif = sub(spec, specexp);
      intermediate(,,specdif,{diff of spec and specexp});

      specmin = min(specdif);
      intermediate(,,specmin,{minimum of difference});

      specmax = max(specdif);
      intermediate(,,specmax,{maximum of difference});

      specrms = rms(specexp);
      intermediate(,,specrms,{root mean square of expected result});

      value(freq);
      intermediate(,,freq,{freq});

      value(freqexp);
      intermediate(,,freqexp,{freqexp});

      freqdif = sub(freq, freqexp);
      intermediate(,,freqdif,{freqdif});

      freqmin = min(freqdif);
      intermediate(,,freqmin,{minimum of difference});

      freqmax = max(freqdif);
      intermediate(,,freqmax,{maximum of difference});

      freqrms = rms(freqexp);
   } 
   -resultname {freqrms} 
   -resultcomment {root mean square of expected result} 
}
\end{verbatim} 
\hspace*{\fill} {\bf Pass / Fail}

\item Verify that the minimimum and maximum values of the differences for 
the power spectrum estimate and discrete frequency values are zero to floating 
point (or double) precision relative to the rms amplitude of the 
expected power spectrum estimate and discrete frequency values.\\
\hspace*{\fill} {\bf Pass / Fail}
\item Move the output file to {\tt mdc/output/api}.\\
\hspace*{\fill} {\bf Pass / Fail}

\item (fft length = 256, overlap length = 128) 
Issue the following ldas command
\begin{verbatim}
ldasJob { -name user -password ***** -email user@host }
  { conditionData 
    -inputprotocol { 
      file:/mdc/input/N10XX.sim
      file:/mdc/input/PSDAPI02CXX.exp 
    }
    -inputformat ilwd 
    -returnprotocol file:/PSDAPI02CXX.ilwd
    -returnformat ilwd 
    -aliases {data=chan_01:data; freqexp=freqout:data; specexp=specout:data} 
    -algorithms { 
      x = slice(data, 0, 1024, 1);
      intermediate(,,chan_01:data,{slice of input data});
      
      spec = psd(freq, x, 256, _, 128, _);
      intermediate(,,spec,{spec});

      value(specexp);
      intermediate(,,specexp,{specexp});

      specdif = sub(spec, specexp);
      intermediate(,,specdif,{diff of spec and specexp});

      specmin = min(specdif);
      intermediate(,,specmin,{minimum of difference});

      specmax = max(specdif);
      intermediate(,,specmax,{maximum of difference});

      specrms = rms(specexp);
      intermediate(,,specrms,{root mean square of expected result});

      value(freq);
      intermediate(,,freq,{freq});

      value(freqexp);
      intermediate(,,freqexp,{freqexp});

      freqdif = sub(freq, freqexp);
      intermediate(,,freqdif,{freqdif});

      freqmin = min(freqdif);
      intermediate(,,freqmin,{minimum of difference});

      freqmax = max(freqdif);
      intermediate(,,freqmax,{maximum of difference});

      freqrms = rms(freqexp);
   } 
   -resultname {freqrms} 
   -resultcomment {root mean square of expected result} 
}
\end{verbatim} 
\hspace*{\fill} {\bf Pass / Fail}

\item Verify that the minimimum and maximum values of the differences for 
the power spectrum estimate and discrete frequency values are zero to floating 
point (or double) precision relative to the rms amplitude of the 
expected power spectrum estimate and discrete frequency values.\\
\hspace*{\fill} {\bf Pass / Fail}
\item Move the output file to {\tt mdc/output/api}.\\
\hspace*{\fill} {\bf Pass / Fail}

\end{enumerate}

\noindent
{\bf SUMMARY}
\vspace{1em}

\noindent    
{\bf Known faults encountered -- list bug IDs: }\hrulefill\\
\vspace{1em}
\hrule
\vspace{1em}
\noindent
{\bf New faults submitted -- list bug IDs: }\hrulefill \\
\vspace{1em}
\hrule
\vspace{2em}

\noindent
{\bf TEST RESULT } \hfill {\bf Pass / Fail }\\

%% End of test PSDEstimate02
